# std::mask_array< Type > Class Template Reference

Reference to selected subset of an array. More...

`#include <mask_array.h>`

List of all members.

## Public Member Functions

| mask_array (const mask_array &)
| Copy constructor. Both slices refer to the same underlying array.
mask_array & | operator= (const mask_array &)
| Assignment operator. Assigns elements to corresponding elements of a.
void | operator *= (const valarray< Type > &) const
| Multiply slice elements by corresponding elements of v.
void | operator/= (const valarray< Type > &) const
| Divide slice elements by corresponding elements of v.
void | operator%= (const valarray< Type > &) const
| Modulo slice elements by corresponding elements of v.
void | operator+= (const valarray< Type > &) const
| Add corresponding elements of v to slice elements.
void | operator-= (const valarray< Type > &) const
| Subtract corresponding elements of v from slice elements.
void | operator^= (const valarray< Type > &) const
| Logical xor slice elements with corresponding elements of v.
void | operator &= (const valarray< Type > &) const
| Logical and slice elements with corresponding elements of v.
void | operator|= (const valarray< Type > &) const
| Logical or slice elements with corresponding elements of v.
void | operator<<= (const valarray< Type > &) const
| Left shift slice elements by corresponding elements of v.
void | operator>>= (const valarray< Type > &) const
| Right shift slice elements by corresponding elements of v.
void | operator= (const Type &) const
| Assign all slice elements to t.

## Detailed Description

### template<class Type>
class std::mask_array< Type >

Reference to selected subset of an array.

A mask_array is a reference to the actual elements of an array specified by a bitmask in the form of an array of bool. The way to get a mask_array is to call operator[](valarray<bool>) on a valarray. The returned mask_array then permits carrying operations out on the referenced subset of elements in the original valarray.

For example, if a mask_array is obtained using the array (false, true, false, true) as an argument, the mask array has two elements referring to array[1] and array[3] in the underlying array.

Parameters:

  | Tp | Element type.

Definition at line 61 of file mask_array.h.

## Constructor & Destructor Documentation

template<typename Type>
std::mask_array< Type >::mask_array | ( | const mask_array< Type > & |  | ) | `[inline]`

| Copy constructor. Both slices refer to the same underlying array. Definition at line 139 of file mask_array.h.

## Member Function Documentation

template<class Type>
void std::mask_array< Type >::operator &= | ( | const valarray< Type > & |  | ) | const

| Logical and slice elements with corresponding elements of v.

template<class Type>
void std::mask_array< Type >::operator *= | ( | const valarray< Type > & |  | ) | const

| Multiply slice elements by corresponding elements of v.

template<class Type>
void std::mask_array< Type >::operator%= | ( | const valarray< Type > & |  | ) | const

| Modulo slice elements by corresponding elements of v.

template<class Type>
void std::mask_array< Type >::operator+= | ( | const valarray< Type > & |  | ) | const

| Add corresponding elements of v to slice elements.

template<class Type>
void std::mask_array< Type >::operator-= | ( | const valarray< Type > & |  | ) | const

| Subtract corresponding elements of v from slice elements.

template<class Type>
void std::mask_array< Type >::operator/= | ( | const valarray< Type > & |  | ) | const

| Divide slice elements by corresponding elements of v.

template<class Type>
void std::mask_array< Type >::operator<<= | ( | const valarray< Type > & |  | ) | const

| Left shift slice elements by corresponding elements of v.

template<typename Type>
void std::mask_array< Type >::operator= | ( | const Type & |  | ) | const`[inline]`

| Assign all slice elements to t. Definition at line 158 of file mask_array.h.

template<typename Type>
mask_array< Type > & std::mask_array< Type >::operator= | ( | const mask_array< Type > & |  | ) | `[inline]`

| Assignment operator. Assigns elements to corresponding elements of a. Definition at line 149 of file mask_array.h.

template<class Type>
void std::mask_array< Type >::operator>>= | ( | const valarray< Type > & |  | ) | const

| Right shift slice elements by corresponding elements of v.

template<class Type>
void std::mask_array< Type >::operator^= | ( | const valarray< Type > & |  | ) | const

| Logical xor slice elements with corresponding elements of v.

template<class Type>
void std::mask_array< Type >::operator|= | ( | const valarray< Type > & |  | ) | const

| Logical or slice elements with corresponding elements of v.

The documentation for this class was generated from the following file:

- mask_array.h